<?php
/*
Plugin Name: cSlider
Description: Add content Slider to posts and pages.
Version: 2.0
Author: Julian Weinert // cs&m
Author URI: http://www.csundm.de
*/

/*
cSlider (Wordpress Plugin)
Copyright (C) 2009 Julian Weinert // cs&m
Contact us at http://www.csundm.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

This plugin is integrated with bxSlider <http://www.bxslider.com> and jQuery.
bxSlider is licenced under the termes of the MIT Licence. See <http://www.opensource.org/licenses/mit-license.php>.
*/
    
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////  Hover image core function ///////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function cSlider($atts, $content)
{
    $width = get_option("width");
    $mode = get_option("mode");
    $speed = get_option("speed");
    $infiniteLoop = get_option("infiniteLoop");
    $controls = get_option("controls");
    $startingSlide = get_option("startingSlide");
    $randomStart = get_option("randomStart");
    $hideControlOnEnd = get_option("hideControlOnEnd");
    $auto = get_option("auto");
    $pause = get_option("pause");
    $autoDirection = get_option("autoDirection");
    $autoHover = get_option("autoHover");
    $pager = get_option("pager");
    $pagerLocation = get_option("pagerLocation");
    $ticker = get_option("ticker");
    $tickerSpeed = get_option("tickerSpeed");
    $tickerDirection = get_option("tickerDirection");
    $tickerHover = get_option("tickerHover");
    
    if($atts["width"])
    {
        $width = $atts["width"];
    }
    if($atts["mode"])
    {
        $mode = $atts["mode"];
    }
    if($atts["speed"])
    {
        $speed = $atts["speed"];
    }
    if($atts["infiniteLoop"])
    {
        $infiniteLoop = $atts["infiniteLoop"];
    }
    if($atts["controls"])
    {
        $controls = $atts["controls"];
    }
    if($atts["startingSlide"])
    {
        $startingSlide = $atts["startingSlide"];
    }
    if($atts["randomStart"])
    {
        $randomStart = $atts["randomStart"];
    }
    if($atts["hideControlOnEnd"])
    {
        $hideControlOnEnd = $atts["hideControlOnEnd"];
    }
    if($atts["auto"])
    {
        $auto = $atts["auto"];
    }
    if($atts["pause"])
    {
        $pause = $atts["pause"];
    }
    if($atts["autoDirection"])
    {
        $autoDirection = $atts["autoDirection"];
    }
    if($atts["autoHover"])
    {
        $autoHover = $atts["autoHover"];
    }
    if($atts["pager"])
    {
        $pager = $atts["pager"];
    }
    if($atts["pagerLocation"])
    {
        $pagerLocation = $atts["pagerLocation"];
    }
    if($atts["ticker"])
    {
        $ticker = $atts["ticker"];
    }
    if($atts["tickerSpeed"])
    {
        $tickerSpeed = $atts["tickerSpeed"];
    }
    if($atts["tickerDirection"])
    {
        $tickerDirection = $atts["tickerDirection"];
    }
    if($atts["tickerHover"])
    {
        $tickerHover = $atts["tickerHover"];
    }
    
	$htmlOutput = "<script src=\"http://code.jquery.com/jquery-latest.js\" type=\"text/javascript\"></script>
    <script src=\"http://bxslider.com/sites/default/files/jquery.bxSlider.min.js\" type=\"text/javascript\"></script>
    <script type=\"text/javascript\">
    $(document).ready(function(){
    $('.cslider').bxSlider({
        prevSelector:'#prevSel',
        nextSelector:'#nextSel',
        mode:'".$mode."',
        speed:".$speed.",
        infiniteLoop:".$infiniteLoop.",
        controls:".$controls.",
        startingSlide:".$startingSlide.",
        randomStart:".$randomStart.",
        hideControlOnEnd:".$hideControlOnEnd.",
        auto:".$auto.",
        pause:".$pause.",
        autoDirection:'".$autoDirection."',
        autoHover:".$autoHover.",
        pager:".$pager.",
        pagerLocation:'".$pagerLocation."',
        ticker:".$ticker.",
        tickerSpeed:".$tickerSpeed.",
        tickerDirection:'".$tickerDirection."',
        tickerHover:".$tickerHover."});
    });
    </script>
    <style>
    td {
        padding:0;
        margin:0;
    }
    .bx-slide-slide {
        width: ".$width."px;
    }
    .bx-next {
        position:absolute;
        width: 30px;
        height: 30px;
        text-indent: -999999px;
        background: url(".WP_PLUGIN_URL."/cslider/gray_next.png) no-repeat 0 -30px;
    }
    .bx-prev {
        position:absolute;
        width: 30px;
        height: 30px;
        text-indent: -999999px;
        background: url(".WP_PLUGIN_URL."/cslider/gray_prev.png) no-repeat 0 -30px;
    }
    .bx-pager a {
        display:block;
        float:left;
        margin-right: 5px;
        margin-top:10px;
        width:10px;
        height:11px;
        color: #fff;
        padding: 0 0 0 0;
        text-indent: -999999px;
        font-size: 12px;
        zoom:1;
        background: url(".WP_PLUGIN_URL."/cslider/gray_pager.png) no-repeat 0 -10px;
    }
    .bx-pager .pager-active {
        background-position-y:0px;
    }
    </style>
    <div class=\"bx-wrapper\">
    <table style=\"width:".($width)."px;\"><tr><td style=\"width:50px;\"><div id=\"prevSel\" style=\"width:30px; margin-right:20px;\"></div></td><td>
    <div class=\"cslider\">";
    $slides = explode("[slide]", $content);
    for($a = 0; $a < sizeof($slides); $a++)
    {
        $htmlOutput .= "<div class=\"bx-slide-slide\">".$slides[$a]."</div>";
    }
    $htmlOutput .= "</div></td><td style=\"width:50ox;\"><div id=\"nextSel\" style=\"width:30px; maring-left:20px;\"></div></td></tr></table></div>";
    return do_shortcode($htmlOutput);
}
add_shortcode("cSlider", "cSlider");

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////// Hover image admin panel //////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function cslide_options()
{
	$width = get_option("width");
}

function set_cslide_options() // Called while activating the Plugin
{
	add_option("width", "300");
    add_option("mode", "horizontal");
    add_option("speed", "500");
    add_option("infiniteLoop", true);
    add_option("controls", true);
    add_option("startingSlide", "0");
    add_option("randomStart", false);
    add_option("hideControlOnEnd", false);
    add_option("auto", false);
    add_option("pause", "3000");
    add_option("autoDirection", "next");
    add_option("autoHover", false);
    add_option("pager", true);
    add_option("pagerLocation", "bottom");
    add_option("ticker", false);
    add_option("tickerSpeed", "5000");
    add_option("tickerDirection", "next");
    add_option("tickerHover", false);
}

function unset_cslide_options() // Called while deactivating the Plugin
{
	delete_option("width");
	delete_option("mode");
	delete_option("speed");
	delete_option("infiniteLoop");
	delete_option("controls");
	delete_option("startingSlide");
	delete_option("randomStart");
	delete_option("hideControlOnEnd");
	delete_option("auto");
	delete_option("pause");
	delete_option("autoDirection");
	delete_option("autoHover");
	delete_option("pager");
	delete_option("pagerLocation");
	delete_option("ticker");
	delete_option("tickerSpeed");
	delete_option("tickerDirection");
	delete_option("tickerHover");
}

register_activation_hook(__FILE__, "set_cslide_options");
register_deactivation_hook(__FILE__, "unset_cslide_options");

function admin_cslide_options() // Including the form for the Plugin settings into Settings Page
{
	?><div class="wrap"><h2>cSlider Settings (Version <?php echo getPluginVersion(); ?>)</h2><?php
	
	if($_REQUEST["submit"])
	{
		update_cslide_options();
	}
	print_cslide_form();
	
	?></div><?php
}

function update_cslide_options() // Update function for the plugin Settings
{
	$ok = false;
	
	if($_REQUEST["width"])
	{
		update_option("width", $_REQUEST["width"]);
		$ok = true;
	}
	if($_REQUEST["mode"])
	{
		update_option("mode", $_REQUEST["mode"]);
		$ok = true;
	}
	if($_REQUEST["speed"])
	{
		update_option("speed", $_REQUEST["speed"]);
		$ok = true;
	}
	if($_REQUEST["infiniteLoop"] == "on")
	{
		update_option("infiniteLoop", "true");
		$ok = true;
	}
    else
	{
		update_option("infiniteLoop", "false");
		$ok = true;
	}
	if($_REQUEST["controls"] == "on")
	{
		update_option("controls", "true");
		$ok = true;
	}
    else
	{
		update_option("controls", "false");
		$ok = true;
	}
	if(($_REQUEST["startingSlide"]) && ($_REQUEST["startingSlide"] != "0"))
	{
		update_option("startingSlide", $_REQUEST["startingSlide"]);
		$ok = true;
	}
    elseif($_REQUEST["startingSlide"] == "0")
    {
		update_option("startingSlide", "0");
		$ok = true;
	}
	if($_REQUEST["randomStart"] == "on")
	{
		update_option("randomStart", "true");
		$ok = true;
	}
    else
	{
		update_option("randomStart", "false");
		$ok = true;
	}
	if($_REQUEST["hideControlOnEnd"] == "on")
	{
		update_option("hideControlOnEnd", "true");
		$ok = true;
	}
    else
	{
		update_option("hideControlOnEnd", "false");
		$ok = true;
	}
	if($_REQUEST["auto"] == "on")
	{
		update_option("auto", "true");
		$ok = true;
	}
    else
	{
		update_option("auto", "false");
		$ok = true;
	}
	if($_REQUEST["pause"])
	{
		update_option("pause", $_REQUEST["width"]);
		$ok = true;
	}
	if($_REQUEST["autoDirection"])
	{
		update_option("autoDirection", $_REQUEST["autoDirection"]);
		$ok = true;
	}
	if($_REQUEST["autoHover"] == "on")
	{
		update_option("autoHover", "true");
		$ok = true;
	}
    else
	{
		update_option("autoHover", "false");
		$ok = true;
	}
	if($_REQUEST["pager"] == "on")
	{
		update_option("pager", "true");
		$ok = true;
	}
    else
	{
		update_option("pager", "false");
		$ok = true;
	}
	if($_REQUEST["pagerLocation"])
	{
		update_option("pagerLocation", $_REQUEST["pagerLocation"]);
		$ok = true;
	}
	if($_REQUEST["ticker"] == "on")
	{
		update_option("ticker", "true");
		$ok = true;
	}
    else
	{
		update_option("ticker", "false");
		$ok = true;
	}
	if($_REQUEST["tickerSpeed"])
	{
		update_option("tickerSpeed", $_REQUEST["tickerSpeed"]);
		$ok = true;
	}
	if($_REQUEST["tickerDirection"])
	{
		update_option("tickerDirection", $_REQUEST["tickerDirection"]);
		$ok = true;
	}
	if($_REQUEST["tickerHover"] == "on")
	{
		update_option("tickerHover", "true");
		$ok = true;
	}
    else
	{
		update_option("tickerHover", "false");
		$ok = true;
	}
	if($ok)
	{
		?><div id="message" class="updated fade">
			<p>Changes saved.</p>
		</div><?php
	}
	else
	{
		?><div id="message" class="error fade">
			<p>Failed to save changes.</p>
		</div><?php
	}
}

function print_cslide_form() // Form for the Plugin Settings
{
    $width = get_option("width");
    $mode = get_option("mode");
    $speed = get_option("speed");
    $infiniteLoop = get_option("infiniteLoop");
    $controls = get_option("controls");
    $startingSlide = get_option("startingSlide");
    $randomStart = get_option("randomStart");
    $hideControlOnEnd = get_option("hideControlOnEnd");
    $auto = get_option("auto");
    $pause = get_option("pause");
    $autoDirection = get_option("autoDirection");
    $autoHover = get_option("autoHover");
    $pager = get_option("pager");
    $pagerLocation = get_option("pagerLocation");
    $ticker = get_option("ticker");
    $tickerSpeed = get_option("tickerSpeed");
    $tickerDirection = get_option("tickerDirection");
    $tickerHover = get_option("tickerHover");
	?>
	<form method="post">
		<table cellspacing="10">
            <thead>
                <tr>
                    <th style="text-align:left;">
                        cSlider default Settings
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        Width:
                    </td>
                    <td>
                        <input type="text" name="width" value="<?php echo $width; ?>" /> px
                    </td>
                    <td>
                        <i>The default width for sliders.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Transition Mode:
                    </td>
                    <td>
                        <select name="mode">
                            <option <?php if($mode == "horizontal"){echo "selected";} ?> value="horizontal">Horizontal</option>
                            <option <?php if($mode == "vertical"){echo "selected";} ?> value="vertical">Vertical</option>
                            <option <?php if($mode == "fade"){echo "selected";} ?> value="fade">Crossfade</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td>
                        Transition Speed:
                    </td>
                    <td>
                        <input type="number" min="0" name="speed" value="<?php echo $speed; ?>" /> ms
                    </td>
                    <td>
                        <i>The default speed for transitions.</i>
                    </td>
                </tr>
                    <td>
                        Infinite Loop:
                    </td>
                    <td>
                        <input type="checkbox" name="infiniteLoop" <?php if($infiniteLoop == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Whether the slides should repeat.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Show navigation arrows:
                    </td>
                    <td>
                        <input type="checkbox" name="controls" <?php if($controls == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                </tr>
                <tr>
                    <td>
                        Start slide index:
                    </td>
                    <td>
                        <input type="number" min="0" name="startingSlide" value="<?php echo $startingSlide; ?>" />
                    </td>
                    <td>
                        <i>The index of the first slide to appear.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Random start:
                    </td>
                    <td>
                        <input type="checkbox" name="randomStart" <?php if($randomStart == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Whether the first slide to appear is random.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        <strike>Hide controls at flanks</strike>:
                    </td>
                    <td>
                        <input type="checkbox" disabled name="hideControlOnEnd" <?php if($hideControlOnEnd == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Not working yet!</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Auto sliding:
                    </td>
                    <td>
                        <input type="checkbox" name="auto" <?php if($auto == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Automated sliding. Before every slide a delay of "pause" field.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Pause between slides:
                    </td>
                    <td>
                        <input type="number" min="0" name="pause" value="<?php echo $pause; ?>" /> ms
                    </td>
                </tr>
                <tr>
                    <td>
                        Automated slide direction:
                    </td>
                    <td>
                        <select name="autoDirection">
                            <option <?php if($autoDirection == "next"){echo "selected";} ?> value="next">Next</option>
                            <option <?php if($autoDirection == "prev"){echo "selected";} ?> value="prev">Previous</option>
                        </select>
                    </td>
                    <td>
                        <i>The slide direction of automated slides.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Pause automated slides on hover:
                    </td>
                    <td>
                        <input type="checkbox" name="autoHover" <?php if($autoHover == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Pauses the automated sliding on mouseover.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Pager:
                    </td>
                    <td>
                        <input type="checkbox" name="pager" <?php if($pager == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Displays the page navigation.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Pager location:
                    </td>
                    <td>
                        <select name="pagerLocation">
                            <option <?php if($pagerLocation == "bottom"){echo "selected";} ?> value="bottom">Bottom</option>
                            <option <?php if($pagerLocation == "top"){echo "selected";} ?> value="top">Top</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td>
                        Ticker:
                    </td>
                    <td>
                        <input type="checkbox" name="ticker" <?php if($ticker == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Whether the slider should slide continuously with a speed of "Ticker speed" field.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Ticker speed:
                    </td>
                    <td>
                        <input type="number" min="1" max="5000" name="tickerSpeed" value="<?php echo $tickerSpeed; ?>" />
                    </td>
                    <td>
                        <i>A value between 1 and 5000.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Ticker direction:
                    </td>
                    <td>
                        <select name="tickerDirection">
                            <option <?php if($tickerDirection == "next"){echo "selected";} ?> value="next">Next</option>
                            <option <?php if($tickerDirection == "prev"){echo "selected";} ?> value="prev">Previous</option>
                        </select>
                    </td>
                    <td>
                        <i>The slide direction of the tciker.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        Stop ticker on hover:
                    </td>
                    <td>
                        <input type="checkbox" name="tickerHover" <?php if($tickerHover == "true"){echo "checked=\"checked\"";} ?> />
                    </td>
                    <td>
                        <i>Pauses the ticker on mouseover.</i>
                    </td>
                </tr>
                <tr>
                    <td>
                        <input type="submit" name="submit" value="Save settings" />
                    </td>
                </tr>
            </tbody>
		</table>
	</form>
	<?php
}

function add_cSliderOptions() // The Function that adds The Plugin to the menu
{
	add_options_page("cSlider", "cSlider", "manage_options", __FILE__, "admin_cslide_options");
}

add_action("admin_menu", "add_cSliderOptions"); // Call the function above into "admin_menu"
        
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////// Supporting functions /////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        
function getPluginVersion()
{
    $pluginData = get_plugin_data(__FILE__);
    return $pluginData['Version'];
}
?>